import React, { Component } from 'react';
import { Text, Platform } from 'react-native';
import PropTypes from 'prop-types';

export default class H1 extends Component {
  static propTypes = {
    children: PropTypes.node.isRequired,
    marginTop: PropTypes.number,
    marginLeft: PropTypes.number,
    fontSize: PropTypes.number,
    color: PropTypes.string,
    textAlign: PropTypes.string,
    onPress: PropTypes.func,
    fontWeight: PropTypes.string,
    isFontScalingAllowed: PropTypes.bool,
    fontFamily: PropTypes.string,
    style: PropTypes.object
  };

  static defaultProps = {
    marginTop: 0,
    marginLeft: 0,
    fontSize: 21,
    color: '#4d4d4d',
    textAlign: 'left',
    onPress: null,
    fontWeight: 'normal',
    isFontScalingAllowed: false,
    fontFamily: Platform.OS == 'android' ? 'sans-serif' : 'Apple SD Gothic Neo',
    style: {}
  };

  render() {
    return (
      <Text
        onPress={this.props.onPress}
        style={[
          {
            marginLeft: this.props.marginLeft,
            backgroundColor: 'transparent',
            fontSize: this.props.fontSize,
            color: this.props.color,
            marginTop: this.props.marginTop,
            textAlign: this.props.textAlign,
            fontWeight: this.props.fontWeight,
            fontFamily: this.props.fontFamily
          },
          this.props.style
        ]}
        allowFontScaling={this.props.isFontScalingAllowed}
      >
        { this.props.children }
      </Text>
    );
  }
}
