import React, { Component } from 'react';
import { Switch } from 'react-native';
import PropTypes from 'prop-types';

export default class _Switch extends Component {
  static propTypes = {
    onChange: PropTypes.func,
    value: PropTypes.bool,
    name: PropTypes.string,
    isDisabled: PropTypes.bool,
    debounce: PropTypes.number
  };

  static defaultProps = {
    onChange: () => {},
    value: false,
    name: '',
    isDisabled: false,
    debounce: 1000
  };

  state = {
    isSwitchPressed: false
  };

  onChangeSwitch = (value) => {
    if (this.state.isSwitchPressed) {
      return;
    }

    this.setState({
      isSwitchPressed: true
    });

    setTimeout(() => {
      this.setState({
        isSwitchPressed: false
      });
    }, this.props.debounce);

    this.props.onChange(value, this.props.name);
  };

  render() {
    const isDisabled = this.props.isDisabled || this.state.isSwitchPressed;

    return (
      <Switch onValueChange={this.onChangeSwitch} value={this.props.value} disabled={isDisabled} />
    );
  }
}
